%define _buildid .9

%global py26nvr python26-imaging-%{version}-%{release}
%global py26builddir %{_builddir}/%{py26nvr}
%global py26doc ../%{py26nvr}

%global py27nvr python27-imaging-%{version}-%{release}
%global py27builddir %{_builddir}/%{py27nvr}
%global py27doc ../%{py27nvr}

%bcond_with X11      # without
%bcond_with sane     # without
%bcond_without tests # with

%global upstream_name Imaging
%global py26inc %{_includedir}/python2.6
%global py27inc %{_includedir}/python2.7

Name: python-imaging
Version: 1.1.6
Release: 19%{?_buildid}%{?dist}
Summary: Python's own image processing library
Group: System Environment/Libraries
License: MIT
URL: http://www.pythonware.com/products/pil/
Source0: http://effbot.org/downloads/Imaging-%{version}.tar.gz
Patch0: %{name}-no-xv.patch
Patch1: %{name}-lib64.patch
Patch2: %{name}-giftrans.patch
Patch3: %{name}-1.1.6-sane-types.patch
Patch4: %{name}-shebang.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: python26
BuildRequires: python27

%description
Python Imaging Library

The Python Imaging Library (PIL) adds image processing capabilities
to your Python interpreter.

This library provides extensive file format support, an efficient
internal representation, and powerful image processing capabilities.

Notice that in order to reduce the package dependencies there are
three subpackages: devel (for development); tk (to interact with the
tk interface) and sane (scanning devices interface).

%package -n python26-imaging
Summary: Python's own image processing library
BuildRequires: python26-devel
BuildRequires: libjpeg-devel
BuildRequires: zlib-devel
BuildRequires: freetype-devel
Provides: python-imaging = %{version}-%{release}
Provides: python-imaging%{?_isa} = %{version}-%{release}
Obsoletes: python-imaging <= 1.1.6-19.6.amzn1

%description -n python26-imaging
Python Imaging Library

The Python Imaging Library (PIL) adds image processing capabilities
to your Python interpreter.

This library provides extensive file format support, an efficient
internal representation, and powerful image processing capabilities.

Notice that in order to reduce the package dependencies there are
three subpackages: devel (for development); tk (to interact with the
tk interface) and sane (scanning devices interface).

This package is meant to be used with Python 2.6.

%package -n python26-imaging-devel
Summary: Development files for python26-imaging
Group: Development/Libraries
Requires: python26-imaging = %{version}-%{release}
Requires: python26-devel
Requires: libjpeg-devel
Requires: zlib-devel
Obsoletes: python-imaging-devel <= 1.1.6-19.6.amzn1
Provides: python-imaging-devel = %{version}-%{release}
Provides: python-imaging-devel%{?_isa} = %{version}-%{release}

%description -n python26-imaging-devel
Development files for python26-imaging.

%if %{with sane}
%package -n python26-imaging-sane
Summary: Python 2.6 module for using scanners
Group: System Environment/Libraries
BuildRequires: sane-backends-devel
Requires: python26-imaging = %{version}-%{release}
Obsoletes: python-imaging-sane <= 1.1.6-19.6.amzn1
Provides: python-imaging-sane = %{version}-%{release}

%description -n python26-imaging-sane
This package contains the sane module for Python 2.6 which provides access to
various raster scanning devices such as flatbed scanners and digital cameras.
%endif

%if %{with X11}
%package -n python26-imaging-tk
Summary: Tk interface for python26-imaging
Group: System Environment/Libraries
BuildRequires: tkinter26
BuildRequires: tk-devel
Requires: python26-imaging = %{version}-%{release}
Requires: tkinter26
Obsoletes: python-imaging-tk <= 1.1.6-19.6.amzn1
Provides: python-imaging-tk = %{version}-%{release}

%description -n python26-imaging-tk
This package contains a Tk interface for python26-imaging.
%endif

%package -n python27-imaging
Summary: Python's own image processing library
BuildRequires: python27-devel
BuildRequires: libjpeg-devel
BuildRequires: zlib-devel
BuildRequires: freetype-devel

%description -n python27-imaging
Python Imaging Library

The Python Imaging Library (PIL) adds image processing capabilities
to your Python interpreter.

This library provides extensive file format support, an efficient
internal representation, and powerful image processing capabilities.

Notice that in order to reduce the package dependencies there are
three subpackages: devel (for development); tk (to interact with the
tk interface) and sane (scanning devices interface).

This package is meant to be used with Python 2.7.

%package -n python27-imaging-devel
Summary: Development files for python27-imaging
Group: Development/Libraries
Requires: python27-imaging = %{version}-%{release}
Requires: python27-devel
Requires: libjpeg-devel
Requires: zlib-devel

%description -n python27-imaging-devel
Development files for python27-imaging.

%if %{with sane}
%package -n python27-imaging-sane
Summary: Python 2.7 module for using scanners
Group: System Environment/Libraries
BuildRequires: sane-backends-devel
Requires: python27-imaging = %{version}-%{release}

%description -n python27-imaging-sane
This package contains the sane module for Python 2.7 which provides access to
various raster scanning devices such as flatbed scanners and digital cameras.
%endif

%if %{with X11}
%package -n python27-imaging-tk
Summary: Tk interface for python27-imaging
Group: System Environment/Libraries
BuildRequires: tkinter27
BuildRequires: tk-devel
Requires: python27-imaging = %{version}-%{release}
Requires: tkinter27

%description -n python27-imaging-tk
This package contains a Tk interface for python27-imaging.
%endif

%prep
%setup -q -n %{upstream_name}-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1 -b .sane-types
%patch4 -p1 -b .shebang

%build
rm -rf %{py26builddir}
mkdir -p %{py26builddir}
cp -a * %{py26builddir}
pushd %{py26builddir}
CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing" %{__python26} setup.py build 
popd

rm -rf %{py27builddir}
mkdir -p %{py27builddir}
cp -a * %{py27builddir}
pushd %{py27builddir}
CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing" %{__python27} setup.py build 
popd

pushd %{py26builddir}/Scripts
%{__python26_shebang} *.py
chmod 755 *.py
popd

%if %{with sane}
pushd %{py26builddir}/Sane
CFLAGS="$RPM_OPT_FLAGS" %{__python26} setup.py build
popd
%endif

pushd %{py27builddir}/Scripts
%{__python27_shebang} *.py
chmod 755 *.py
popd

%if %{with sane}
pushd %{py27builddir}/Sane
CFLAGS="$RPM_OPT_FLAGS" %{__python27} setup.py build
popd
%endif

%install
rm -rf %{buildroot}

pushd %{py26builddir}
%{__python26} setup.py install -O1 --skip-build --root %{buildroot} --install-layout=amzn
popd
mkdir -p %{buildroot}/%{py26inc}/Imaging
install -m 644 libImaging/*.h %{buildroot}/%{py26inc}/Imaging

%if %{with sane}
pushd %{py26builddir}/Sane
%{__python26} setup.py install -O1 --skip-build --root %{buildroot}
%endif

# There is no need to ship the binaries since they are packaged in %%doc
rm -rf %{buildroot}%{_bindir}

pushd %{py27builddir}
%{__python27} setup.py install -O1 --skip-build --root %{buildroot} --install-layout=amzn
popd
mkdir -p %{buildroot}/%{py27inc}/Imaging
install -m 644 libImaging/*.h %{buildroot}/%{py27inc}/Imaging

%if %{with sane}
pushd %{py27builddir}/Sane
%{__python27} setup.py install -O1 --skip-build --root %{buildroot}
%endif

# There is no need to ship the binaries since they are packaged in %%doc
rm -rf %{buildroot}%{_bindir}
VERSIONS=(
26
27
)
PYSITEARCH26=%{python26_sitearch}
PYSITEARCH27=%{python27_sitearch}

for py in ${VERSIONS[@]} ; do
  # Separate files that need Tk and files that don't
  echo '%%defattr (0644,root,root,755)' > files.main${py}
  echo '%%defattr (0644,root,root,755)' > files.tk${py}
  p="$PWD"
  pysitearch="PYSITEARCH$py"
  pysitearch="${!pysitearch}"

  pushd %{buildroot}"${pysitearch}/PIL"
  for file in *; do
    case "$file" in
    ImageTk*|SpiderImagePlugin*|_imagingtk.so)
%if %{with X11}
        what=files.tk${py}
%else
        rm -f "$file"
        continue
%endif
        ;;
    *)
        what=files.main${py}
        ;;
    esac
    echo ${pysitearch}/PIL/$file >> "$p/$what"
    echo "$p/$what"
  done
  popd
done

%check
%if %{with tests}
pushd %{py26builddir}
PYTHONPATH=$(ls -1d build/lib.linux*) %{__python26} selftest.py
popd
pushd %{py27builddir}
PYTHONPATH=$(ls -1d build/lib.linux*) %{__python27} selftest.py
popd
%endif

%clean
rm -rf %{buildroot}
rm -rf %{py26builddir}
rm -rf %{py27builddir}

%files -n python26-imaging -f files.main26
%defattr (-,root,root,-)
%doc README CHANGES
%{python26_sitearch}/PIL.pth
%dir %{python26_sitearch}/PIL

%files -n python26-imaging-devel
%defattr (0644,root,root,755)
%{py26inc}/Imaging
%doc %{py26doc}/Docs %{py26doc}/Scripts %{py26doc}/Images

%if %{with sane}
%files -n python26-imaging-sane
%defattr (0644,root,root,755)
%doc %{py26doc}/Sane/CHANGES %{py26doc}/Sane/demo*.py %{py26doc}/Sane/sanedoc.txt
%{python26_sitearch}/pysane*egg-info
%{python26_sitearch}/_sane.so
%{python26_sitearch}/sane.py*
%endif

%if %{with X11}
%files -n python26-imaging-tk -f files.tk26
%endif

%files -n python27-imaging -f files.main27
%defattr (-,root,root,-)
%doc README CHANGES
%{python27_sitearch}/PIL.pth
%dir %{python27_sitearch}/PIL

%files -n python27-imaging-devel
%defattr (0644,root,root,755)
%{py27inc}/Imaging
%doc %{py27doc}/Docs %{py27doc}/Scripts %{py27doc}/Images

%if %{with sane}
%files -n python27-imaging-sane
%defattr (0644,root,root,755)
%doc %{py27doc}/Sane/CHANGES %{py27doc}/Sane/demo*.py %{py27doc}/Sane/sanedoc.txt
%{python27_sitearch}/pysane*egg-info
%{python27_sitearch}/_sane.so
%{python27_sitearch}/sane.py*
%endif

%if %{with X11}
%files -n python27-imaging-tk -f files.tk27
%endif

%changelog
* Mon Feb 2 2015 Ben Cressey <bcressey@amazon.com>
- build for multiple pythons

* Thu Dec 2 2010 Cristian Gafton <gafton@amazon.com>
- import source package RHEL6/python-imaging-1.1.6-19.el6

* Wed Jul 21 2010 Cristian Gafton <gafton@amazon.com>
- conditionalize sane and X11 builds

* Fri Jul 9 2010 Cristian Gafton <gafton@amazon.com>
- import source package RHEL6/python-imaging-1.1.6-18.el6
- import source package RHEL6/python-imaging-1.1.6-17.1.el6

* Mon Jun 14 2010 Roman Rakus <rrakus@redhat.com> - 1.1.6-19
- Use -fno-strict-aliasing CFLAG
  Resolves: #596200

* Fri May 7 2010 Cristian Gafton <gafton@amazon.com>
- import source package RHEL5/python-imaging-1.1.5-5.el5
- added submodule prep for package python-imaging

* Wed Feb 24 2010 Roman Rakus <rrakus@redhat.com> - 1.1.6-18
- Changed License to the MIT (Historical Permission Notice and Disclaimer)

* Fri Nov 13 2009 Dennis Gregorovic <dgregor@redhat.com> - 1.1.6-17.1
- Fix conditional for RHEL

* Tue Sep 08 2009 Joel Granados <jgranado@redhat.com> - 1.1.6-17
- Fix the shebang issue.  See https://fedoraproject.org/wiki/Features/SystemPythonExecutablesUseSystemPython

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.1.6-16
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Apr 15 2009 Karsten Hopp <karsten@redhat.com> 1.1.6-15
- disable sane subpackage and sane requirements for mainframes, we don't have
  sane on s390 and s390x

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.1.6-14
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sat Nov 29 2008 Ignacio Vazquez-Abrams <ivazqueznet+rpm@gmail.com> - 1.1.6-13
- Rebuild for Python 2.6

* Thu Oct  2 2008 José Matos <jamatos[AT]fc.up.pt> - 1.1.6-12
- all patches are applied with -p1

* Thu Oct  2 2008 José Matos <jamatos[AT]fc.up.pt> - 1.1.6-11
- rebuild to avoid the patches fuzziness (#464984)

* Tue Jun 3 2008 Joel Granados <jgranado@redhat.com> - 1.1.6-10
- Fix the build.

* Tue Feb 19 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 1.1.6-9
- Autorebuild for GCC 4.3

* Fri Jan  4 2008 Alex Lancaster <alexlan[AT]fedoraproject org> - 1.1.6-8
- Egg for PIL library is already in subdirectory, and found by glob.

* Fri Jan  4 2008 Alex Lancaster <alexlan[AT]fedoraproject org> - 1.1.6-7
- python_sitelib -> python_sitearch

* Fri Jan  4 2008 Alex Lancaster <alexlan[AT]fedoraproject org> - 1.1.6-6
- Support for Python Eggs for F9+

* Thu Jan  3 2008 José Matos <jamatos[AT]fc.up.pt> - 1.1.6-5
- Rebuild for Tcl/Tk upgrade (F9+).
- Update description to reflect the subpackages.
- Fix files permission.

* Tue Aug 28 2007 José Matos <jamatos[AT]fc.up.pt> - 1.1.6-4
- Rebuild for devel (F8).

* Sun Apr 29 2007 Nils Philippsen <nphilipp@redhat.com> - 1.1.6-3
- add sane subpackage, split off tk subpackage (#238252)
- add sane-types patch
- use -b for patches to save original files
- correct groups

* Wed Feb 14 2007 José Matos <jamatos[AT]fc.up.pt> - 1.1.6-2
- Rebuild for Tcl/Tk downgrade (F7)

* Mon Feb  5 2007 José Matos <jamatos[AT]fc.up.pt> - 1.1.6-1
- New upstream version.
- Clean spec file and specify license as BSD.

* Tue Dec 12 2006 José Matos <jamatos[AT]fc.up.pt> - 1.1.5-7
- Rebuild for python 2.5.

* Tue Aug 29 2006 José Matos <jamatos[AT]fc.up.pt> - 1.1.5-6
- Rebuild for FE6
- Clean package, no need for python-abi requirement and ghost pyo files

* Thu Apr  6 2006 José Matos <jamatos[AT]fc.up.pt> - 1.1.5-5
- Rebuild because of #187739

* Tue Apr  4 2006 José Matos <jamatos[AT]fc.up.pt> - 1.1.5-4
- Rebuild

* Tue Apr  4 2006 José Matos <jamatos[AT]fc.up.pt> - 1.1.5-3
- Restore gif transparency patch. (bug #187875)

* Sun Apr  2 2006 José Matos <jamatos[AT]fc.up.pt> - 1.1.5-2
- Fix bug #185203 (Thanks to Rick L Vinyard Jr)

* Sun Mar  5 2006 José Matos <jamatos[AT]fc.up.pt> - 1.1.5-1
- Update to 1.1.5

* Sun May 22 2005 Jeremy Katz <katzj@redhat.com> - 1.1.4-9
- rebuild on all arches

* Fri Apr  7 2005 Michael Schwendt <mschwendt[AT]users.sf.net>
- rebuilt

* Mon Feb  7 2005 Thorsten Leemhuis <fedora at leemhuis dot info> - 0:1.1.4-7
- Build PIC on x86_64 to fix x86_64 linking.

* Sat Oct  9 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:1.1.4-6
- Borrow parts from patch in Debian's 1.1.4-3 to fix issues in bug 1038 as
  well as a bunch of others.
- Bring up to date with current fedora.us Python spec template recommendations.
- Fix -devel directory permissions.

* Sun Nov 30 2003 Juha Ylitalo <jylitalo@iki.fi> - 0:1.1.4-0.fdr.5
- added -devel package (thanks to patch from pmatilai@welho.com)
- FC1 requires dependency to tcl-devel and tk-devel package

* Wed Jul 16 2003 Juha Ylitalo <jylitalo@iki.fi> - 0:1.1.4-0.fdr.4
- bumped release
- implemented changes from Ville, which basically means that:
- setup macro now users "-q" option
- libpng dropped from buildrequirements
- run test suite after build

* Sat Jul 12 2003 Juha Ylitalo <jylitalo@iki.fi> - 0:1.1.4-0.fdr.3
- fixed source0 to point into effbot.org instead of pythonware.com
- changed references from python2 to python, since python in RH9 is
  python 2.2.
- removed percent signs from changelog.

* Tue Jul 08 2003 Juha Ylitalo <jylitalo@iki.fi> - 0:1.1.4-0.fdr.2
- added XFree86-devel and tkinter into buildrequires.
- removed version info from buildrequires
- removed unnecessary stuff from requires.

* Wed Jun 23 2003 Juha Ylitalo <jylitalo@iki.fi> - 0:1.1.4-0.fdr.1
- new upstream version

* Tue May 20 2003 Juha Ylitalo <jylitalo@iki.fi> - 0:1.1.3-0.fdr.5
- added python2-devel into buildrequires.
- added versionm variable into setup macro instead of hard coded
  version number.

* Mon May 12 2003 Juha Ylitalo <jylitalo@iki.fi> - 0:1.1.3-0.fdr.4
- removed unnecessary ./configure
- /usr/lib -> _libdir macro
- smp flags to make

* Sat May 03 2003 Juha Ylitalo <jylitalo@iki.fi> - 0:1.1.3-0.fdr.3
- changed buildroot macro back to $RP_BUILD_ROOT
- ./configure to configure macro
- Group to Development/Languages
- Added Epoch values to versioned Requires and BuildRequires
- added README and CHANGES-113 into doc

* Wed Mar 26 2003 Juha Ylitalo <jylitalo@iki.fi> - 0:1.1.3-0.fdr.2
- added Epoch
- added URL into Source0
- replaced $RPM_BUILD_ROOT with buildroot macro

* Wed Mar 26 2003 Juha Ylitalo <jylitalo@iki.fi> - 0:1.1.3-0.fdr.1
- modified spec file to fit with fedora guidelines.

* Mon Sep 23 2002 Juha Ylitalo <jylitalo@iki.fi> - 1.1.3-1
- updated to 1.1.3
- switched from python 1.5.2 to python 2.2
- other modifications to make it build at minimal effort

* Tue Sep 12 2000 Ray Garcia <rayg@ssec.wisc.edu>
- update to 1.1

* Thu Mar 30 2000 Frederic Lepied <flepied@mandrakesoft.com> 1.0b1-3mdk
- group fix.

* Mon Jan 10 2000 Lenny Cartier <lenny@mandrakesoft.com>
- build for oxygen
- deactivate provinding of tkinter lib since Chmouel one's works perfectly

* Mon Dec 27 1999 Lenny Cartier <lenny@mandrakesoft.com>
- new in contribs
- bz2 archive

* Mon Jan 11 1999 Oliver Andrich <oli@andrich.net>
- upgraded to Imaging 1.0b1

* Sun Dec 27 1998 Oliver Andrich <oli@andrich.net>
- changed Setup file so that the tkinter module is compiled with Tix and BLT
  support

* Mon Jul 20 1998 Oliver Andrich <oli@andrich.net>
- had to recompile and update the package to support the uptodate graphics
  libs

* Sat Jun 07 1998 Oliver Andrich <oli@andrich.net>
- updated package to version 0.3a4
